﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace OOPBasics
{
    class Program
    {
        static void Main(string[] args)
        {
            //create a person object
            Person myPerson = new Person("Feichtinger","18.03.1980");  

            //wire up the event handler
            myPerson.walked += new Person.walkDelegate(myPerson_walked);            

            myPerson.Walk(2);                   //let the person walk
            myPerson.Walk();                    //let the person walk

            //unwire up the event handler
            myPerson.walked -= new Person.walkDelegate(myPerson_walked);


            int age = myPerson.Age();               //get age
            DateTime born = myPerson.BirthDate;

            Console.WriteLine("Birthdate: {0}, Age:{1}", myPerson.BirthDate.ToShortDateString(), myPerson.Age());

            myPerson.Name = "Feichtinger";      //use property to set the object's name
            Console.WriteLine(myPerson.Name);   //get the object's name using a property

            Console.WriteLine("Number of persons: {0}.", Person.Counter);

            //Advanced concepts
            //create person array and initialize it
            Person[] myPeople = new Person[5];
            myPeople[0] = new Person("Herbert","9.7.1965");
            myPeople[1] = new Person("Kurt","21.1.1955");
            myPeople[2] = new Person("Eva","1.2.1960");
            myPeople[3] = new Person("Paul","13.5.1970");
            myPeople[4] = new Person("Otto","1.10.1975");

            if (Person.CompareAge(myPeople[0], myPeople[1]))
            {
                Console.WriteLine("{0} is older than {1}", myPeople[0].Name, myPeople[1].Name);
            }
            else
            {
                Console.WriteLine("{0} is not older than {1}", myPeople[0].Name, myPeople[1].Name);
            }
            Console.WriteLine();

            //sort the person array by age
            //Sort.DoSort(myPeople, new Sort.Compare(Person.CompareAge));  //long form
            Sort.DoSort(myPeople,Person.CompareAge);  //short form, creates delegate implicitely
            
            //output data to console window: name and age
            foreach (Person p in myPeople)
            {
                Console.WriteLine("{0}: {1}", p.Name, p.Age().ToString());
            }
            Console.WriteLine();

            //sort the person array by name
            Sort.DoSort(myPeople, Person.CompareName);

            //output data to console window: name and age
            foreach (Person p in myPeople)
            {
                Console.WriteLine("{0}: {1}", p.Name, p.Age().ToString());
            }
            Console.ReadLine();
        }
        
        static void myPerson_walked(int d)
        {
            Console.WriteLine("Walked: {0}", d);
        }
        
    }
}
