﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

namespace AdvancedOOP
{
    public enum NameType
    {
        Normal,
        Nick
    }

    class Student : Person, IPrintable
    {
        #region Variables
        private DateTime mEntryDate;
        private double mPocketMoney;
        private Dictionary<NameType,String> mNames = new Dictionary<NameType,string>();
        private String[] mLabels = new String[] {"ID", "PocketMoney", "EntryDate"}; 
        #endregion

        #region constructor
        public Student()
        {
            Debug.WriteLine("Student constructor");
        }
        #endregion

        #region Properties
        public DateTime EntryDate
        {
            get
            {
                return mEntryDate;
            }
            set
            {
                mEntryDate = value;
            }
        }

        public double PocketMoney
        {
            get
            {
                return mPocketMoney;
            }
            set
            {
                mPocketMoney = value;
            }
        }

        public override DateTime BirthDate
        {
            get
            {
                return base.BirthDate;
            }
            set
            {
                if ((DateTime.Now.Year - value.Year) > 14)
                {
                    base.BirthDate = value;
                }
                else
                {
                    throw new ArgumentException("Student must be elder than 14.");
                }
            }
        }

        public new int Age
        {
            get
            {
                //correct formula
                return (DateTime.Now.Year - BirthDate.Year);
            }
        }
        #endregion

        #region Methods
        public void SetName(NameType nt, string name)
        {
            mNames.Add(nt, name);
        }
        public string GetName(NameType nt)
        {
            return mNames[nt];
        }
        #endregion

        #region IPrintable Members
        string IPrintable.Label(int index)
        {
            return mLabels[index];
        }

        string IPrintable.Value(int index)
        {
            switch (index)
            {
                case 0:
                    return this.GetName();
                case 1:
                    return mPocketMoney.ToString();
                case 2:
                    return EntryDate.ToShortDateString();
                default:
                    throw new Exception("Invalid index. Must be 0..2");
                }
        }

        int IPrintable.Count()
        {
            return mLabels.Count();
        }
        #endregion
    }
}
