﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

namespace WindowsEventLog
{
    class Program
    {
        static void Main(string[] args)
        {
            //Step 1: create the event source, if it does not exist
            if (!EventLog.SourceExists("MyApplication"))
            {
                //1st param: source name by which the app is registered on the local computer
                //2nd param: name of log
                EventLog.CreateEventSource("MyApplication", "MyApplicationLog");
            }

            //Step 2: create an eventlog instance and assign its event source
            EventLog myLog = new EventLog();
            myLog.Source = "MyApplication";

            //Step 3: write an informal entry to the event log
            myLog.WriteEntry("Info from MyApplication");

            //WriteEntry() has many overlays:
            myLog.WriteEntry("Warning from MyApplication",EventLogEntryType.Warning);
            myLog.WriteEntry("Error from MyApplication", EventLogEntryType.Error);

            Console.WriteLine("Done!");
            Console.ReadLine();
        }
    }
}
