﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Generics
{
    public class ReadOnlyList<T>
    {
        private List<T> mItems; //list holding the items

        public ReadOnlyList(int elementCount, params T[] values)
        {
            mItems = new List<T>(elementCount);
            foreach (T v in values)
            {
                this.Add(v);
            }
        }

        private void Add(T value)
        {
            if  (!object.Equals(value, null))
            {
                mItems.Add(value);
            }
        }

        public int Count
        {
            get
            {
                return mItems.Count();
            }
        }

  
        //indexer
        public T this[int i]
        {
            get
            {
                return mItems[i];
            }
        }
    }
}
