﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NewGenericDelegates
{
    public enum Genders
    {
        Female,
        Male
    }

    class Student
    {
        private static int mCount = 0;

        public Student (Genders gender, string name, string firstName, DateTime birthDate)
        {
            this.ID = mCount;
            mCount++;

            this.Gender = gender;
            this.Name = name;
            this.FirstName = firstName;
            this.BirthDate = birthDate;
        }

        public String Name { get; private set; }
        public String FirstName { get; private set; }
        public DateTime BirthDate { get; private set; }
        public int ID { get; private set; }
        public Genders Gender { get; private set; }

        public override string ToString()
        {
            return string.Format(@"StudentID: {0}, Name: {1}, {2}\tBorn: {3}; Gender: {4}", 
                this.ID.ToString(), this.Name, this.FirstName, this.BirthDate.ToShortDateString(), this.Gender.ToString());
        }

    }
}
