﻿using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Diagnostics;
using System.Text;

[Serializable()]
public class Department : IComparable
{

    private List<SchoolClass> mSchoolClasses = new List<SchoolClass>();
    public List<SchoolClass> SchoolClasses
    {
        get { return mSchoolClasses; }
        set { mSchoolClasses = value; }
    }

    private static int mCount = 0;

    private int mID;
    public int ID
    {
        get { return mID; }
    }


    private string mName;
    public string Name
    {
        get { return mName; }
        set { mName = value; }
    }

    public Department(string name)
    {
        mID = mCount;
        mCount += 1;
        mName = name;
    }

    //for XML serialization
    private Department()
    {

    }

    public override string ToString()
    {
        StringBuilder sb = new StringBuilder();
        sb.Append("Department ID: " + mID + ", Name: " + mName + ", Nr. of classes: " + mSchoolClasses.Count);
        foreach (SchoolClass s in mSchoolClasses)
        {
            sb.Append("\r\n\t\t" + s.ToString());
        }
        return sb.ToString();
    }

    public int CompareTo(object obj)
    {
        //compare name of dept.
        return this.Name.CompareTo(((SchoolClass)obj).Name);
    }

    public void SortStudentsByGender()
    {
        foreach (SchoolClass sc in mSchoolClasses)
        {
            sc.SortStudentsByGender();
        }
    }

    //Sternzeichen
    public void SortStudentsBySunSign()
    {
        foreach (SchoolClass sc in mSchoolClasses)
        {
            sc.SortStudentsBySunSign();
        }
    }

    //
    public void SortStudentsByBirthdate()
    {
        foreach (SchoolClass sc in mSchoolClasses)
        {
            sc.SortStudentsByBirthdate();
        }
    }
}

