﻿using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Diagnostics;
using System.Text;
using System.ComponentModel;

[Serializable()]
public class SchoolClass : IComparable
{

	//Der Umbaucvon mStudents auf eine BindingList<T> erfordert Änderungen des DatenTypes in allen 
	//aufrufenden Methoden. Alternativ kann man mit DataSource/BindingSource aus eine List eine 
	//BindingList machen.
	//BindingLits<T>.OrderBy erfordert LINQ function delegate.
	private List<Student> mStudents = new List<Student>();
	public List<Student> Students {
		get { return mStudents; }
		set { mStudents = value; }
	}


	private string mClassName;
	public string Name {
		get { return mClassName; }
		set { mClassName = value; }
	}


	private string mRoom;
	public string Room {
		get { return mRoom; }
		set { mRoom = value; }
	}

	private static int mCount = 0;

	private int mID;
	public int ID {
		get { return mID; }
	}

	public SchoolClass(string className, string room)
	{
		mID = mCount;
		mCount += 1;
		mClassName = className;
		mRoom = room;
	}

	//for XML serialization
	private SchoolClass()
	{

	}

	public override string ToString()
	{
		StringBuilder sb = new StringBuilder();
		sb.Append("Schoolclass ID: " + mID + ", ClassName: " + mClassName + ", Room: " + mRoom + ", Nr. of Students: " + mStudents.Count);
		foreach (Student s in mStudents) {
			sb.Append("\r\n\t\t\t" + s.ToString());
		}
		return sb.ToString();
	}

		public int CompareTo(object obj)
	{
		//compare name of class
		return this.Name.CompareTo(((SchoolClass)obj).Name);
	}

	#region "Sort List(of T)"
	//uses Comparison(Of T) Generic Delegate

	public void SortStudentsByName()
	{
		mStudents.Sort();
		//use default comparer
	}

	public void SortStudentsByGender()
	{
		mStudents.Sort(Student.CompareByGender);
	}

	//Sternzeichen
	public void SortStudentsBySunSign()
	{
		mStudents.Sort(Student.CompareBySunSign);
	}

	//
	public void SortStudentsByBirthdate()
	{
		mStudents.Sort(Student.CompareByBirthdate);
	}
	#endregion

   }
