﻿using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Diagnostics;
//Diese Klasse implementiert
//   Public Properties für ua DataBinding
//   parameterloser Konstruktor für XML Serialisierung
//   INotifiyPropertyChanged für DataBinding
//   IComparable für Sortieren nach einem Kriterium: Name
//   und besitzt nested classes, die IComparer implementieren

using System.ComponentModel;

public enum Genders
{
	Female,
	Male
}
//für DataBinding
[Serializable()]
public class Student : IComparable
{
	//für sortieren nach dem 1. Kriterium
	//Implements IComparer        'für Sortieren nach mehreren Kriterien

	private string mName;
	public string Name {
		get { return mName; }
		set { mName = value; }
	}

	private string mFirstName;
	public string FirstName {
		get { return mFirstName; }
		set { mFirstName = value; }
	}

	private DateTime mBirthDate;
	public DateTime BirthDate {
		get { return mBirthDate; }
		set { mBirthDate = value; }
	}

	private int mID;
	public int ID {
		get { return mID; }
	}


	private static int mCount = 0;
	public Student(Genders gender, string name, string firstname, DateTime birthDate)
	{
		mGender = gender;
		mName = name;
		mFirstName = firstname;
		mBirthDate = birthDate;
		mID = mCount;
		//use counter to create the ID, starting at 0
		mCount += 1;
	}

	//for XML serialization
	private Student()
	{

	}

	private Genders mGender;
	public Genders Gender {
		get { return mGender; }
		set { mGender = value; }
	}

	public SunSign Sign {
		//sorted by date:
		//Aquarius    'Aquarius (January 20 - February 18): Humanitarian, unconventional, sometimes detached. 
		//Pisces      'Pisces (February 19 - March 20): Imaginative, sensitive, sometimes impractical. 
		//Aries       'Aries (March 21 - April 19): Assertive, impulsive, sometimes selfish. 
		//Taurus      'Taurus (April 20 - May 20): Resourceful thorough, sometimes indulgent. 
		//Gemini      'Gemini (May 21 - June 20): Logical, inquisitive, sometimes superficial. 
		//Cancer      'Cancer (June 21 - July 22): Tenacious, sensitive, sometimes clinging. 
		//Leo         'Leo (July 23 - August 22): Generous, proud, sometimes arrogant. 
		//Virgo       'Virgo (August 23 - September 22): Practical, efficient, sometimes over-critical. 
		//Libra       'Libra (September 23 - October 22): Co-operative, fair, sometimes lazy. 
		//Scorpio     'Scorpio (October 23 - November 21): Passionate, sensitive, sometimes obsessive. 
		//Sagittarius 'Sagittarius (November 22 - December 21): intelligent, straightforward, sometimes careless. 
		//Capricorn   'Capricorn (December 22 - January 19): Prudent, ambitious, sometimes suspicious. 

		get {
			if ((mBirthDate.Month == 1)) {
				if ((mBirthDate.Day >= 20)) {
					return SunSign.Aquarius;
				} else {
					return SunSign.Capricorn;
				}

			} else if ((mBirthDate.Month == 2)) {
				if ((mBirthDate.Day >= 19)) {
					return SunSign.Pisces;
				} else {
					return SunSign.Aquarius;
				}

			} else if ((mBirthDate.Month == 3)) {
				if ((mBirthDate.Day >= 21)) {
					return SunSign.Aries;
				} else {
					return SunSign.Pisces;
				}

			} else if ((mBirthDate.Month == 4)) {
				if ((mBirthDate.Day >= 20)) {
					return SunSign.Taurus;
				} else {
					return SunSign.Aries;
				}

			} else if ((mBirthDate.Month == 5)) {
				if ((mBirthDate.Day >= 21)) {
					return SunSign.Gemini;
				} else {
					return SunSign.Taurus;
				}

			} else if ((mBirthDate.Month == 6)) {
				if ((mBirthDate.Day >= 21)) {
					return SunSign.Cancer;
				} else {
					return SunSign.Gemini;
				}

			} else if ((mBirthDate.Month == 7)) {
				if ((mBirthDate.Day >= 23)) {
					return SunSign.Leo;
				} else {
					return SunSign.Cancer;
				}

			} else if ((mBirthDate.Month == 8)) {
				if ((mBirthDate.Day >= 23)) {
					return SunSign.Virgo;
				} else {
					return SunSign.Leo;
				}

			} else if ((mBirthDate.Month == 9)) {
				if ((mBirthDate.Day >= 23)) {
					return SunSign.Libra;
				} else {
					return SunSign.Virgo;
				}

			} else if ((mBirthDate.Month == 10)) {
				if ((mBirthDate.Day >= 23)) {
					return SunSign.Scorpio;
				} else {
					return SunSign.Libra;
				}

			} else if ((mBirthDate.Month == 11)) {
				if ((mBirthDate.Day >= 22)) {
					return SunSign.Sagittarius;
				} else {
					return SunSign.Scorpio;
				}

			}
			else if ((mBirthDate.Month == 12))
			{
				if ((mBirthDate.Day >= 22))
				{
					return SunSign.Capricorn;
				}
				else
				{
					return SunSign.Sagittarius;
				}
			}
			else 
			{
				throw new Exception("Invalid sign");
			}
		}
	}

	public override string ToString()
	{
		return ("Student ID: " + mID.ToString() + ", Name: " + mName + ", " + mFirstName + Constants.vbTab + ", Born: " + mBirthDate + "; Gender: " + mGender.ToString());
	}

	#region "Property Changed Event"
	public event PropertyChangedEventHandler PropertyChanged;
	public delegate void PropertyChangedEventHandler(object sender, System.ComponentModel.PropertyChangedEventArgs e);

	protected virtual void OnPropertyChanged(string propertyName)
	{
		if (PropertyChanged != null) {
			PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
		}
	}

	#endregion

	#region "Shared functions for various array sorts"
	public int CompareTo(object obj)
	{
		return (this.Name.CompareTo(((Student)obj).Name));
	}


	//the shared functions offers an easy call to sort: eg Array.Sort(arrayOfStudents, Student.SortByBirthdate)
	public static IComparer<Student> SortByBirthdate()
	{
		return (IComparer<Student>)new SortByBirthdateHelper();
	}

	public static IComparer<Student> SortByGender()
	{
		return (IComparer<Student>)new SortByGenderHelper();
	}

	public static IComparer<Student> SortBySunSign()
	{
		//Sternzeichen
		return (IComparer<Student>)new SortBySunSignHelper();
	}
	#endregion

	#region "Nested classes needed for additional array sort criterias"
	//these classes are needed for additional sort criterias
	//generic comparer to be used by generic List(Of T) !!!
	public class SortByBirthdateHelper : IComparer<Student>
	{
		public int Compare(Student x, Student y)
		{
			return x.BirthDate.CompareTo(y.BirthDate);
		}
	}

	//sort ladies first
	public class SortByGenderHelper : IComparer<Student>
	{
		public int Compare(Student x, Student y)
		{
			if (x.Gender == y.Gender) {
				return 0;
			} else if (x.Gender == Genders.Female & y.Gender == Genders.Male) {
				return -1;
			} else {
				return 1;
			}
		}
	}

	public class SortBySunSignHelper : IComparer<Student>
	{
		public int Compare(Student x, Student y)
		{
			return x.Sign.CompareTo(y.Sign);
		}
	}
	#endregion

	#region "Shared functions for various collection sorts"
	//uses Comparison<T> Generic Delegate
	//this methods are required for sorting List<T> collections

	public static int CompareByBirthdate(Student x, Student y)
	{
		return x.BirthDate.CompareTo(y.BirthDate);
	}

	public static int CompareByGender(Student x, Student y)
	{
		if (x.Gender == y.Gender) {
			return 0;
		} else if (x.Gender == Genders.Female & y.Gender == Genders.Male) {
			return -1;
		} else {
			return 1;
		}
	}

	public static int CompareBySunSign(Student x, Student y)
	{
		return x.Sign.CompareTo(y.Sign);
	}
	#endregion
}


public enum SunSign
{
	//from Wikipedia
	//the signs are sorted by date to enable us to easily compare them for a sorting order!
	Aquarius,
	//Aquarius (January 20 - February 18): Humanitarian, unconventional, sometimes detached. 
	Aries,
	//Aries (March 21 - April 19): Assertive, impulsive, sometimes selfish. 
	Cancer,
	//Cancer (June 21 - July 22): Tenacious, sensitive, sometimes clinging. 
	Capricorn,
	//Capricorn (December 22 - January 19): Prudent, ambitious, sometimes suspicious. 
	Gemini,
	//Gemini (May 21 - June 20): Logical, inquisitive, sometimes superficial. 
	Leo,
	//Leo (July 23 - August 22): Generous, proud, sometimes arrogant. 
	Libra,
	//Libra (September 23 - October 22): Co-operative, fair, sometimes lazy. 
	Pisces,
	//Pisces (February 19 - March 20): Imaginative, sensitive, sometimes impractical. 
	Sagittarius,
	//Sagittarius (November 22 - December 21): intelligent, straightforward, sometimes careless. 
	Scorpio,
	//Scorpio (October 23 - November 21): Passionate, sensitive, sometimes obsessive. 
	Taurus,
	//Taurus (April 20 - May 20): Resourceful thorough, sometimes indulgent. 
	Virgo
	//Virgo (August 23 - September 22): Practical, efficient, sometimes over-critical. 
}

