﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;

namespace XmlDomBased
{
    class Program
    {
        static void Main(string[] args)
        {
            XmlDocument doc = new XmlDocument();
            doc.Load("myCars.xml");
            OutputNode(doc.DocumentElement);
            Console.ReadLine();
        }

        static void OutputNode(XmlNode node)
        {
            //output current element node
            Console.WriteLine("Type=" + node.NodeType.ToString() + "\t" + 
                "Name=" + node.Name + "\t" + "Value=" + node.Value);

            //handle attributes
            if (node.Attributes != null)
            {
                foreach (XmlAttribute att in node.Attributes)
                {
                    Console.WriteLine("\t" + "Type=" + att.NodeType.ToString() +
                        "\t" + "Name=" + att.Name + "\t" + "Value=" + att.Value);
                }
            }

            //handle child nodes recursively
            if (node.HasChildNodes)
            {
                //get collection of child nodes
                XmlNodeList children = node.ChildNodes;
                foreach (XmlNode child in children)
                {
                    OutputNode(child);
                }
            }
        }
    }
}
