﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.IO;

namespace XmlStreamBased
{
    class Program
    {
        static void Main(string[] args)
        {
            ReadMyCars();
            WriteMyNextCar();
            Console.WriteLine("Hit Enter to exit.");
            Console.ReadLine();
        }

        static void ReadMyCars()
        {
            XmlTextReader reader = new XmlTextReader("mycars.xml");
            try
            {
                reader.WhitespaceHandling = WhitespaceHandling.None;
                while (reader.Read())
                {
                 Console.WriteLine("Type= " + reader.NodeType.ToString() + "\t" + 
                                    "Name= " + reader.Name + "\t" +
                                    "Value= " + reader.Value);

                    //handle XML attributes
                    if (reader.AttributeCount > 0)
                    {
                        while (reader.MoveToNextAttribute())
                        {
                            Console.WriteLine("\t" +
                                "Type= " + reader.NodeType.ToString() + "\t" +
                                "Name= " + reader.Name + "\t" +
                                "Value= " + reader.Value);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine("Error: " + ex.Message);
            }
            finally
            {
                if (reader != null) reader.Close();
            }
        }

        static void WriteMyNextCar()
        {
            XmlTextWriter writer = 
                new XmlTextWriter("MyNextCar.xml", System.Text.Encoding.Unicode);
            try
            {
                writer.Formatting = Formatting.Indented;

                writer.WriteStartDocument();
                writer.WriteStartElement("MyCollection");

                writer.WriteStartElement("Manufacturer");
                writer.WriteAttributeString("Name", "Opel");
                writer.WriteAttributeString("City", "Rüsselsheim");

                writer.WriteStartElement("Model");
                writer.WriteAttributeString("Name", "Astra G");

                writer.WriteElementString("ManufacturerDate", "2001");
                writer.WriteElementString("Power","75");
                writer.WriteElementString("Torque", "75"); 
                writer.WriteElementString("Consumption", "5.4");
                writer.WriteElementString("Acceleration", "10.4");
                writer.WriteElementString("TopSpeed", "175");

                writer.WriteEndElement();
                writer.WriteEndElement();

                writer.WriteEndElement();
                writer.WriteEndDocument();
            }
            catch (Exception ex)
            {
                Console.WriteLine("Error: " + ex.Message);
            }
            finally
            {
                if (writer != null) writer.Close();
            }
        }
    }
}
