﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

namespace SimpleSerialization
{
    class GenericSerializer
    {
        static public void SerializeToFile<T>(string path, T obj)
        {
            using (FileStream fs = new FileStream(path, System.IO.FileMode.Create))
            {
                BinaryFormatter bf = 
                   new BinaryFormatter(null, new StreamingContext(StreamingContextStates.File));
                bf.Serialize(fs, obj);
            }
        }

        static public T DeserializeFromFile<T>(String path)
        {
            using (FileStream fs = new FileStream(path, System.IO.FileMode.Open))
            {
                BinaryFormatter bf =
                    new BinaryFormatter(null, new StreamingContext(StreamingContextStates.File));
                return ((T)bf.Deserialize(fs));
            }
        }
    }
}
