﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization.Formatters.Binary;

namespace SimpleSerialization
{
    [Serializable()] 
    public class Person
    {
        public Person(String name, String firstName, Double salary, DateTime birthDate)
        {
            this.Name = name;
            this.FirstName = firstName;
            this.Salary = salary;
            this.BirthDate = birthDate;
        }

        public String Name { get; set; }
        public String FirstName { get; set; }
        public Double Salary { get; set; }
        public DateTime BirthDate { get; set; }

        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append(this.Name);
            sb.Append(", ");
            sb.Append(this.FirstName);
            sb.Append(": born ");
            sb.Append(this.BirthDate.ToShortDateString());
            sb.Append(". Earns: ");
            sb.Append(string.Format("{0:c}",this.Salary));
            return sb.ToString();
        }
    }
}
